using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;

namespace Encoder
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class EncoderForm: System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label keyLabel;
		private System.Windows.Forms.TextBox keyTextBox;
		private System.Windows.Forms.Label inLabel;
		private System.Windows.Forms.Label outLabel;
		private System.Windows.Forms.TextBox inTextBox;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.TextBox outTextBox;
		private System.Windows.Forms.MainMenu mainMenu1;

		public EncoderForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.keyLabel = new System.Windows.Forms.Label();
			this.keyTextBox = new System.Windows.Forms.TextBox();
			this.inTextBox = new System.Windows.Forms.TextBox();
			this.inLabel = new System.Windows.Forms.Label();
			this.outLabel = new System.Windows.Forms.Label();
			this.outTextBox = new System.Windows.Forms.TextBox();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.Add(this.menuItem1);
			this.mainMenu1.MenuItems.Add(this.menuItem2);
			// 
			// menuItem1
			// 
			this.menuItem1.Text = "Encode";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Text = "Exit";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// keyLabel
			// 
			this.keyLabel.Location = new System.Drawing.Point(8, 16);
			this.keyLabel.Size = new System.Drawing.Size(40, 24);
			this.keyLabel.Text = "Key";
			// 
			// keyTextBox
			// 
			this.keyTextBox.Location = new System.Drawing.Point(56, 16);
			this.keyTextBox.PasswordChar = '*';
			this.keyTextBox.Size = new System.Drawing.Size(112, 25);
			this.keyTextBox.Text = "";
			// 
			// inTextBox
			// 
			this.inTextBox.Location = new System.Drawing.Point(56, 56);
			this.inTextBox.Size = new System.Drawing.Size(112, 25);
			this.inTextBox.Text = "";
			// 
			// inLabel
			// 
			this.inLabel.Location = new System.Drawing.Point(8, 56);
			this.inLabel.Size = new System.Drawing.Size(40, 22);
			this.inLabel.Text = "In";
			// 
			// outLabel
			// 
			this.outLabel.Location = new System.Drawing.Point(8, 96);
			this.outLabel.Size = new System.Drawing.Size(36, 22);
			this.outLabel.Text = "Out";
			// 
			// outTextBox
			// 
			this.outTextBox.Location = new System.Drawing.Point(56, 96);
			this.outTextBox.ReadOnly = true;
			this.outTextBox.Size = new System.Drawing.Size(112, 25);
			this.outTextBox.Text = "";
			// 
			// EncoderForm
			// 
			this.Controls.Add(this.keyLabel);
			this.Controls.Add(this.keyTextBox);
			this.Controls.Add(this.inLabel);
			this.Controls.Add(this.inTextBox);
			this.Controls.Add(this.outLabel);
			this.Controls.Add(this.outTextBox);
			this.Menu = this.mainMenu1;
			this.Text = "Encoder";

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new EncoderForm());
		}

		private string encode ( string input, string key ) 
		{
			if ( key.Length == 0 ) 
			{
				return "No key";
			}
			if ( input.Length == 0 ) 
			{
				return "No input";
			}
			char [] keyChars = key.ToCharArray();
			int keypos = 0 ;
			
			System.Text.StringBuilder result = new System.Text.StringBuilder();
			foreach ( char ch in input ) 
			{
				int cval = ch - 32;
				int pval = keyChars[keypos]-32;
				result.Append((char)((cval ^ pval) + 32));
				keypos++;
				if ( keypos == key.Length ) 
				{
					keypos = 0 ;
				}
			}
			return result.ToString() ;
		}

		private void doEncode () 
		{
			outTextBox.Text = encode ( inTextBox.Text, keyTextBox.Text ) ;
		}

		private void menuItem1_Click(object sender, System.EventArgs e)
		{
			doEncode();
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}
	}
}
