using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;

namespace Encoder
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class EncoderForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label keyLabel;
		private System.Windows.Forms.TextBox keyTextBox;
		private System.Windows.Forms.Label inLabel;
		private System.Windows.Forms.TextBox inTextBox;
		private System.Windows.Forms.Label outLabel;
		private System.Windows.Forms.Button encodeButton;
		private System.Windows.Forms.TextBox outTextBox;
		private System.Windows.Forms.MainMenu mainMenu1;

		public EncoderForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.keyLabel = new System.Windows.Forms.Label();
			this.keyTextBox = new System.Windows.Forms.TextBox();
			this.inLabel = new System.Windows.Forms.Label();
			this.inTextBox = new System.Windows.Forms.TextBox();
			this.outLabel = new System.Windows.Forms.Label();
			this.encodeButton = new System.Windows.Forms.Button();
			this.outTextBox = new System.Windows.Forms.TextBox();
			// 
			// keyLabel
			// 
			this.keyLabel.Location = new System.Drawing.Point(40, 8);
			this.keyLabel.Size = new System.Drawing.Size(40, 24);
			this.keyLabel.Text = "Key";
			// 
			// keyTextBox
			// 
			this.keyTextBox.Location = new System.Drawing.Point(88, 8);
			this.keyTextBox.PasswordChar = '*';
			this.keyTextBox.Size = new System.Drawing.Size(112, 20);
			this.keyTextBox.Text = "";
			// 
			// inLabel
			// 
			this.inLabel.Location = new System.Drawing.Point(40, 48);
			this.inLabel.Size = new System.Drawing.Size(40, 22);
			this.inLabel.Text = "In";
			// 
			// inTextBox
			// 
			this.inTextBox.Location = new System.Drawing.Point(88, 44);
			this.inTextBox.Size = new System.Drawing.Size(112, 20);
			this.inTextBox.Text = "";
			// 
			// outLabel
			// 
			this.outLabel.Location = new System.Drawing.Point(40, 88);
			this.outLabel.Size = new System.Drawing.Size(36, 22);
			this.outLabel.Text = "Out";
			// 
			// encodeButton
			// 
			this.encodeButton.Location = new System.Drawing.Point(64, 128);
			this.encodeButton.Size = new System.Drawing.Size(128, 40);
			this.encodeButton.Text = "Encode";
			this.encodeButton.Click += new System.EventHandler(this.encodeButton_Click);
			// 
			// outTextBox
			// 
			this.outTextBox.Location = new System.Drawing.Point(88, 80);
			this.outTextBox.ReadOnly = true;
			this.outTextBox.Size = new System.Drawing.Size(112, 20);
			this.outTextBox.Text = "";
			// 
			// EncoderForm
			// 
			this.Controls.Add(this.outTextBox);
			this.Controls.Add(this.encodeButton);
			this.Controls.Add(this.keyLabel);
			this.Controls.Add(this.keyTextBox);
			this.Controls.Add(this.inLabel);
			this.Controls.Add(this.inTextBox);
			this.Controls.Add(this.outLabel);
			this.Menu = this.mainMenu1;
			this.Text = "Encoder";

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new EncoderForm());
		}

		private string encode ( string input, string key ) 
		{
			if ( key.Length == 0 ) 
			{
				return "No key";
			}
			if ( input.Length == 0 ) 
			{
				return "No input";
			}
			char [] keyChars = key.ToCharArray();
			int keypos = 0 ;
			
			System.Text.StringBuilder result = new System.Text.StringBuilder();
			foreach ( char ch in input ) 
			{
				int cval = ch - 32;
				int pval = keyChars[keypos]-32;
				result.Append((char)((cval ^ pval) + 32));
				keypos++;
				if ( keypos == key.Length ) 
				{
					keypos = 0 ;
				}
			}
			return result.ToString() ;
		}

		private void doEncode () 
		{
			outTextBox.Text = encode ( inTextBox.Text, keyTextBox.Text ) ;
		}

		private void encodeButton_Click(object sender, System.EventArgs e)
		{
			doEncode() ;
		}
	}
}
